﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.IO;
using System.Runtime.Serialization.Formatters;

namespace EnemyPlacementTester
{
    [Serializable]
    public abstract class CEnemyItem : IDiagramItem
    {
        #region fields and their properties
        protected Rectangle area;

        public Rectangle Area
        {
            get { return area; }
            set { area = value; }
        }

        protected Image sprite;

        public Image Sprite
        {
            get { return sprite; }
            set { sprite = value; }
        }

        protected int visionRange;

        public int VisionRange
        {
            get { return visionRange; }
            set { visionRange = value; }
        }

        protected int repulsionRange;

        public int RepulsionRange
        {
            get { return repulsionRange; }
            set { repulsionRange = value; }
        }

        protected eEnemy type;

        public eEnemy Type
        {
            get { return type; }
            set { type = value; }
        }
        #endregion

        #region constructor
        public CEnemyItem(eEnemy newType, Image newImage, Point newPoint, int newVisionRange, int newRepulsionRange)
        {
            type = newType;
            sprite = newImage;
            area = new Rectangle(newPoint.X - (newImage.Width / 2), newPoint.Y - (newImage.Height / 2), newImage.Width, newImage.Height);
            visionRange = newVisionRange;
            repulsionRange = newRepulsionRange;
        }
        #endregion

        #region methods
        public abstract bool containsPoint(Point p);
        public abstract void draw(Graphics g, bool showVision, bool showRepulsion, bool currentSelection);
        public abstract string getExportData();
        public abstract void updatePosition(Point newPosition, bool usingMouse);
        #endregion
    }
}
